﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using WindowsApplication1;
using Infragistics.Win.UltraWinToolbars;
using Infragistics.Win;

namespace WindowsFormsApplication1
{
    public partial class UserControl1 : UserControl
    {
        public UserControl1()
        {
            InitializeComponent();
            //EventBroadcastProvider broadcastEvent = EventBroadcastProvider.CreateProvider(this, "MouseHover");
            //this.ultraToolbarsManager1.MouseEnterElement += ultraToolbarsManager1_MouseEnterElement;
        }

        private void ultraToolbarsManager1_ToolClick(object sender, Infragistics.Win.UltraWinToolbars.ToolClickEventArgs e)
        {
            Console.WriteLine("ToolClick " + e.Tool.Key);
        }


        private Dictionary<string, int> _dragging = new Dictionary<string, int>();

        private void ultraToolbarsManager1_MouseEnterElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            if (e.Element is Infragistics.Win.UltraWinToolbars.ButtonToolUIElement)
            {
                ButtonToolUIElement button = e.Element as Infragistics.Win.UltraWinToolbars.ButtonToolUIElement;

                lock (this)
                {
                    if (!_dragging.ContainsKey(button.Tool.Key) || _dragging[button.Tool.Key] == 0)
                    {
                        _dragging[button.Tool.Key] = 0;
                        DoDragDrop(button.Tool, DragDropEffects.Copy);
                    }
                    Console.WriteLine(String.Format("{2} Mouse Enter Button Tool Key = {0} Name = {1}", button.Tool.Key, button.Tool.CaptionResolved, _dragging[button.Tool.Key]));
                    _dragging[button.Tool.Key]++;
                }
            }
        }

        void ultraToolbarsManager1_MouseLeaveElement(object sender, UIElementEventArgs e)
        {
            if (e.Element is Infragistics.Win.UltraWinToolbars.ButtonToolUIElement)
            {
                ButtonToolUIElement button = e.Element as Infragistics.Win.UltraWinToolbars.ButtonToolUIElement;


                lock (this)
                {
                    Console.WriteLine(String.Format("{2} Mouse Leave Button Tool Key = {0} Name = {1}", button.Tool.Key, button.Tool.CaptionResolved, _dragging[button.Tool.Key]));
                    if (_dragging.ContainsKey(button.Tool.Key))
                        _dragging[button.Tool.Key]--;
                }
            }
        }


        private void UserControl1_QueryContinueDrag(object sender, QueryContinueDragEventArgs e)
        {

            //e.Action = DragAction.Continue; //(_dragging.Where(kvp => kvp.Value > 0).Any() ? DragAction.Continue : DragAction.Cancel);
            
            Console.WriteLine(String.Format("UserControl1_QueryContinueDrag {0}", e.Action.ToString()));
        }
       
    }
}
